
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   16:23:52 04/26/2007
-- Design Name:   oslb_cpld
-- Module Name:   C:/iseproj/oslb_cpld_v2/cpld_tb.vhd
-- Project Name:  HTR_SLB_CPLDv2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: oslb_cpld
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY cpld_tb_vhd IS
END cpld_tb_vhd;

ARCHITECTURE behavior OF cpld_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT oslb_cpld
	PORT(
		loc_add : IN std_logic_vector(6 downto 0);
		loc_rw : IN std_logic;
		loc_cs : IN std_logic;
		cclk_fb : IN std_logic;
		cclk : IN std_logic;
		init_b : IN std_logic;
		done : IN std_logic;
		ctrl_in : IN std_logic_vector(2 downto 0);    
		loc_bus : INOUT std_logic_vector(7 downto 0);
		mdata : INOUT std_logic_vector(7 downto 0);      
		loc_add_out : OUT std_logic_vector(6 downto 0);
		maddr : OUT std_logic_vector(18 downto 0);
		moe_b : OUT std_logic;
		mce_b : OUT std_logic;
		mwe_b : OUT std_logic;
		cclk_fbp : OUT std_logic;
		cclkp : OUT std_logic;
		prog_b : OUT std_logic;
		cs_b : OUT std_logic;
		spare5 : OUT std_logic;
		rdwr_b : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL loc_rw :  std_logic := '0';
	SIGNAL loc_cs :  std_logic := '1';
	SIGNAL cclk_fb :  std_logic := '0';
	SIGNAL cclk :  std_logic := '0';
	SIGNAL init_b :  std_logic := '0';
	SIGNAL done :  std_logic := '0';
	SIGNAL loc_add :  std_logic_vector(6 downto 0) := (others=>'0');
	SIGNAL ctrl_in :  std_logic_vector(2 downto 0) := (others=>'0');

	--BiDirs
	SIGNAL loc_bus :  std_logic_vector(7 downto 0);
	SIGNAL mdata :  std_logic_vector(7 downto 0);

	--Outputs
	SIGNAL loc_add_out :  std_logic_vector(6 downto 0);
	SIGNAL maddr :  std_logic_vector(18 downto 0);
	SIGNAL moe_b :  std_logic;
	SIGNAL mce_b :  std_logic;
	SIGNAL mwe_b :  std_logic;
	SIGNAL cclk_fbp :  std_logic;
	SIGNAL cclkp :  std_logic;
	SIGNAL prog_b :  std_logic;
	SIGNAL cs_b :  std_logic;
	SIGNAL spare5 :  std_logic;
	SIGNAL rdwr_b :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: oslb_cpld PORT MAP(
		loc_add => loc_add,
		loc_add_out => loc_add_out,
		loc_bus => loc_bus,
		loc_rw => loc_rw,
		loc_cs => loc_cs,
		maddr => maddr,
		mdata => mdata,
		moe_b => moe_b,
		mce_b => mce_b,
		mwe_b => mwe_b,
		cclk_fb => cclk_fb,
		cclk_fbp => cclk_fbp,
		cclk => cclk,
		cclkp => cclkp,
		prog_b => prog_b,
		cs_b => cs_b,
		spare5 => spare5,
		rdwr_b => rdwr_b,
		init_b => init_b,
		done => done,
		ctrl_in => ctrl_in
	);
cclk <= cclkp;
cclk_fb <=  not cclk_fb after 10ns;
	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;

		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
